Draft: PathArray

From FreeCAD Documentation
This page is a translated version of the page Draft PathArray and the translation is 7% complete.
Outdated translations are marked like this.

Draft PathArray

poziția meniului
Draft → PathArray
Ateliere
Draft, Arch
scurtătură
nici unul
Prezentat în versiune
0.14
A se vedea, de asemenea,
Draft Array

Descriere

Instrumentul PathArray plasează copii ale unei forme selectate de-a lungul unei căi selectate. Calea poate fi un Filament sau una sau mai multe muchii. Formele pot fi opțional aliniate cu tangenta traiectoriei. Dacă este necesar, poate fi specificat un Vector de tranlație pentru a deplasa formele astfel încât centroidul să fie pe traiectorie. Dacă nu sunt selectate obiecte, veți fi invitat să le selectați.

Both commands can be used on 2D objects created with the Draft Workbench or Sketcher Workbench, but also on many 3D objects such as those created with the Part Workbench, PartDesign Workbench or Arch Workbench.

Draft PathArray

Cum se folosește

  1. Creați un obiect tip formă pe care doriți să îl distribuiți/multiplicați. Veți obține cele mai bune rezultate dacă obiectul dvs. este centrat în jurul originii, chiar dacă calea începe în altă parte.
  2. Selectați un obiect tip traiectorie de-a lungul căruia vor fi distribuite formele. -sau-
  3. Selectați unele margini ale unui obiect traiectorie.
  4. Apasați pe butonul Draft PathArray.

Alignment

The alignment of the elements in a Draft PathArray depends on the properties of the array and the orientation of the source object. The position of the source object is ignored: for the purpose of the array the x, y and z are set to 0. If the DateAlign property of the array is set to false the orientation of the array elements is identical to that of the source object. If it is set to true the X axis of the local coordinate system of each element placement is tangent to the path. The Y and Z axes of the local coordinate systems depend on the DateAlign Mode property of the array. Other array properties involved in the alignment include DateTangent Vector, DateForce Vertical and DateVertical Vector.

3 arrays based on the same non-planar path. From left to right: Align is false, Align is true with Align Mode Original and Align is true with Align Mode Frenet

.

Align Mode

Three modes are available:

Original

This mode comes closest to the single DateAlign Mode available in version 0.18. It relies on a fixed normal vector. If the path is planar this vector is perpendicular to the plane of the path, else a default vector, the positive Z axis, is used. From this normal vector and the local tangent vector (the local X axis) a cross product is calculated. This new vector is used as the local Z axis. The orientation of the local Y axis is determined from the local X and Z axes.

Frenet

This mode uses the local normal vector derived from the path at each element placement. If this vector cannot be determined (for example in the case of a straight segment) a default vector, again the positive Z axis, is used instead. With this vector and the local tangent vector the local coordinate system is determined using the same procedure as in the previous paragraph.

Tangent

This mode is similar to DateAlign Mode Original but includes the possibility to pre-rotate the source object by specifying a DateTangent Vector.

Force Vertical and Vertical Vector

These properties are only available if DateAlign Mode is Original or Tangent. If DateForce Vertical is set to true the local coordinate system is calculated in a different manner. The DateVertical Vector is used as a fixed normal vector. From this normal vector and the local tangent vector (the local X axis) again a cross product is calculated. But now this vector is used as the local Y axis. The orientation of the local Z axis is determined from the local X and Y axes.

Using these properties can be required if one of the edged of the path is (almost) parallel to the default normal of the path.

Proprietăți

See also: Property editor.

A Draft PathArray object is derived from a Part Feature object and inherits all its properties (with the exception of some View properties that are not inherited by Link arrays). The following properties are additional unless otherwise stated:

Data

Link

The properties in this group are only available for Link arrays. See Std LinkMake for more information.

  • DateScale (Float)
  • Date (Hidden)Scale Vector (Vector)
  • DateScale List (VectorList)
  • Date (Hidden)Visibility List (BoolList)
  • Date (Hidden)Placement List (PlacementList)
  • Date (Hidden)Element List (LinkList)
  • Date (Hidden)_ Link Touched (Bool)
  • Date (Hidden)_ Child Cache (LinkList)
  • Date (Hidden)Colored Elements (LinkSubHidden)
  • DateLink Transform (Bool)

Alignment

  • DateBase: Obiectul tip formă
  • DatePathObj: Obeictul tip traiectorie
  • DatePathSubs: Sub-elementele(edges) obeictului tip traiectorie car va fi utilizat
  • DateCount: Numărul de ori de repetarea a formei
  • DateXlate: Vectorul de translație
  • DateAlign: Este adevărat să aliniați formele la traiectorie, False pentru a lăsa forme în orientarea lor implicită.

Objects

  • DateBase (LinkGlobal): specifies the object to duplicate in the array.
  • DateCount (Integer): specifies the number of elements in the array.
  • DateExpand Array (Bool): specifies whether to expand the array in the Tree view to enable the selection of its individual elements. Only available for Link arrays.
  • DatePath Object (LinkGlobal): specifies the object to be used for the path. It must contain Edges in its Part TopoShape.
  • DatePath Subelements (LinkSubListGlobal): specifies a list of edges of the DatePath Object. If supplied only these edges are used for the path.

View

Link

The properties in this group, with the exception of the inherited property, are only available for Link arrays. See Std LinkMake for more information.

  • VizualizareDraw Style (Enumeration)
  • VizualizareLine Width (FloatConstraint)
  • VizualizareOverride Material (Bool)
  • VizualizarePoint Size (FloatConstraint)
  • VizualizareSelectable (Bool): this is an inherited property that appears in the Selection group for other arrays
  • VizualizareShape Material (Material)

Base

The properties in this group, with the exception of the inherited property, are only available for Link arrays. See Std LinkMake for more information.

  • Vizualizare (Hidden)Child View Provider (PersistentObject)
  • Vizualizare (Hidden)Material List (MaterialList)
  • Vizualizare (Hidden)Override Color List (ColorList)
  • Vizualizare (Hidden)Override Material List (BoolList)
  • Vizualizare (Hidden)Proxy (PythonObject): this is an inherited property.

Display Options

The properties in this group are inherited properties. See Part Feature for more information.

  • VizualizareBounding Box (Bool): this property is not inherited by Link arrays.
  • VizualizareDisplay Mode (Enumeration): for Link arrays it can be Link or ChildView. For other arrays it can be: Flat Lines, Shaded, Wireframe or Points
  • VizualizareShow In Tree (Bool)
  • VizualizareVisibility (Bool)

Draft

  • VizualizarePattern (Enumeration): not used.
  • VizualizarePattern Size (Float): not used.

Object style

The properties in this group are not inherited by Link arrays.

Scripting

Scrip-Programare

Instrumentul PathArray poate fi utilizat în macros și de la consola Python utilizând umătoarea funcție:

path_array = make_path_array(base_object, path_object,
                             count=4, extra=App.Vector(0, 0, 0), subelements=None,
                             align=False, align_mode="Original", tan_vector=App.Vector(1, 0, 0),
                             force_vertical=False, vertical_vector=App.Vector(0, 0, 1),
                             use_link=True)
  • Plasează un numpr de copii ale unui obiect tip formă al documentului de-a lungul unui obiect tip traiectorie sau sub-obiecte ale unui path-object. Opțional translatează fiecare copie prin FreeCAD.Vector xlate pe direcția și la distanța pentru a ajusta pentru diferența de formă centru vs punct de referință. Opțional, aliniază elementul de bază la calea tangentă/normală/binormală.

Exempluː

import FreeCAD as App
import Draft

doc = App.newDocument()

p1 = App.Vector(500, -1000, 0)
p2 = App.Vector(1500, 1000, 0)
p3 = App.Vector(3000, 500, 0)
p4 = App.Vector(4500, 100, 0)
spline = Draft.make_bspline([p1, p2, p3, p4])
obj = Draft.make_polygon(3, 500)

path_array = Draft.make_path_array(obj, spline, 6)
doc.recompute()

wire = Draft.make_wire([p1, -p2, -p3, -p4])
path_array2 = Draft.make_path_array(obj, wire, count=3, extra=App.Vector(0, -500, 0), subelements=["Edge2", "Edge3"], align=True, force_vertical=True)
doc.recompute()